Index: main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/browser.py
===================================================================
--- main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/browser.py	(revision 9168)
+++ main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/browser.py	(revision 9169)
@@ -43,5 +43,5 @@
 from waeup.kofa.interfaces import (
     IKofaObject, IUserAccount, IExtFileStore, IPasswordValidator, IContactForm,
-    IKofaUtils, IUniversity)
+    IKofaUtils, IUniversity, IObjectHistory)
 from waeup.kofa.interfaces import MessageFactory as _
 from waeup.kofa.widgets.datewidget import (
@@ -53,11 +53,14 @@
     IUGStudentClearance,IPGStudentClearance,
     IStudentPersonal, IStudentBase, IStudentStudyCourse,
+    IStudentStudyCourseTransfer,
     IStudentAccommodation, IStudentStudyLevel,
     ICourseTicket, ICourseTicketAdd, IStudentPaymentsContainer,
-    IStudentOnlinePayment, IBedTicket, IStudentsUtils, IStudentRequestPW
+    IStudentOnlinePayment, IStudentPreviousPayment,
+    IBedTicket, IStudentsUtils, IStudentRequestPW
     )
 from waeup.kofa.students.catalog import search
 from waeup.kofa.students.workflow import (CREATED, ADMITTED, PAID,
-    CLEARANCE, REQUESTED, RETURNING, CLEARED, REGISTERED, VALIDATED)
+    CLEARANCE, REQUESTED, RETURNING, CLEARED, REGISTERED, VALIDATED,
+    FORBIDDEN_POSTGRAD_TRANS)
 from waeup.kofa.students.studylevel import StudentStudyLevel, CourseTicket
 from waeup.kofa.students.vocabularies import StudyLevelSource
@@ -65,4 +68,5 @@
 from waeup.kofa.hostels.hostel import NOT_OCCUPIED
 from waeup.kofa.utils.helpers import get_current_principal, to_timezone
+from waeup.kofa.mandates.mandate import PasswordMandate
 
 grok.context(IKofaObject) # Make IKofaObject the default context
@@ -91,4 +95,17 @@
     return
 
+def translated_values(view):
+    lang = view.request.cookies.get('kofa.language')
+    for value in view.context.values():
+        value_dict = dict([i for i in value.__dict__.items()])
+        value_dict['mandatory_bool'] = value.mandatory
+        value_dict['mandatory'] = translate(str(value.mandatory), 'zope',
+            target_language=lang)
+        value_dict['carry_over'] = translate(str(value.carry_over), 'zope',
+            target_language=lang)
+        value_dict['automatic'] = translate(str(value.automatic), 'zope',
+            target_language=lang)
+        yield value_dict
+
 class StudentsBreadcrumb(Breadcrumb):
     """A breadcrumb for the students container.
@@ -116,5 +133,10 @@
     """
     grok.context(IStudentStudyCourse)
-    title = _('Study Course')
+
+    def title(self):
+        if self.context.is_current:
+            return _('Study Course')
+        else:
+            return _('Previous Study Course')
 
 class PaymentsBreadcrumb(Breadcrumb):
@@ -279,10 +301,13 @@
     grok.require('waeup.viewStudent')
     grok.template('basepage')
-    form_fields = grok.AutoFields(IStudentBase).omit('password')
+    form_fields = grok.AutoFields(IStudentBase).omit('password', 'suspended')
     pnav = 4
 
     @property
     def label(self):
-        return _('${a}: Base Data',
+        if self.context.suspended:
+            return _('${a}: Base Data (account deactivated)',
+                mapping = {'a':self.context.display_fullname})
+        return  _('${a}: Base Data',
             mapping = {'a':self.context.display_fullname})
 
@@ -292,4 +317,10 @@
             return _('set')
         return _('unset')
+
+class StudentBasePDFFormPage(KofaDisplayFormPage):
+    """ Page to display student base data in pdf files.
+    """
+    form_fields = grok.AutoFields(IStudentBase).omit(
+        'password', 'suspended', 'phone', 'adm_code', 'sex')
 
 class ContactStudentForm(ContactAdminForm):
@@ -336,5 +367,6 @@
     grok.name('manage_base')
     grok.require('waeup.manageStudent')
-    form_fields = grok.AutoFields(IStudentBase).omit('student_id')
+    form_fields = grok.AutoFields(IStudentBase).omit(
+        'student_id', 'adm_code', 'suspended')
     grok.template('basemanagepage')
     label = _('Manage base data')
@@ -362,4 +394,7 @@
         allowed_transitions = [t for t in self.wf_info.getManualTransitions()
             if not t[0].startswith('pay')]
+        if self.context.is_postgrad:
+            allowed_transitions = [t for t in allowed_transitions
+                if not t[0] in FORBIDDEN_POSTGRAD_TRANS]
         return [dict(name='', title=_('No transition'))] +[
             dict(name=x, title=y) for x, y in allowed_transitions]
@@ -396,4 +431,42 @@
         return
 
+class StudentActivatePage(UtilityView, grok.View):
+    """ Activate student account
+    """
+    grok.context(IStudent)
+    grok.name('activate')
+    grok.require('waeup.manageStudent')
+
+    def update(self):
+        self.context.suspended = False
+        self.context.writeLogMessage(self, 'account activated')
+        history = IObjectHistory(self.context)
+        history.addMessage('Student account activated')
+        self.flash(_('Student account has been activated.'))
+        self.redirect(self.url(self.context))
+        return
+
+    def render(self):
+        return
+
+class StudentDeactivatePage(UtilityView, grok.View):
+    """ Deactivate student account
+    """
+    grok.context(IStudent)
+    grok.name('deactivate')
+    grok.require('waeup.manageStudent')
+
+    def update(self):
+        self.context.suspended = True
+        self.context.writeLogMessage(self, 'account deactivated')
+        history = IObjectHistory(self.context)
+        history.addMessage('Student account deactivated')
+        self.flash(_('Student account has been deactivated.'))
+        self.redirect(self.url(self.context))
+        return
+
+    def render(self):
+        return
+
 class StudentClearanceDisplayFormPage(KofaDisplayFormPage):
     """ Page to display student clearance data
@@ -411,7 +484,9 @@
     def form_fields(self):
         if self.context.is_postgrad:
-            form_fields = grok.AutoFields(IPGStudentClearance).omit('clearance_locked')
-        else:
-            form_fields = grok.AutoFields(IUGStudentClearance).omit('clearance_locked')
+            form_fields = grok.AutoFields(
+                IPGStudentClearance).omit('clearance_locked')
+        else:
+            form_fields = grok.AutoFields(
+                IUGStudentClearance).omit('clearance_locked')
         return form_fields
 
@@ -432,7 +507,9 @@
     def form_fields(self):
         if self.context.is_postgrad:
-            form_fields = grok.AutoFields(IPGStudentClearance).omit('clearance_locked')
-        else:
-            form_fields = grok.AutoFields(IUGStudentClearance).omit('clearance_locked')
+            form_fields = grok.AutoFields(
+                IPGStudentClearance).omit('clearance_locked')
+        else:
+            form_fields = grok.AutoFields(
+                IUGStudentClearance).omit('clearance_locked')
         return form_fields
 
@@ -446,15 +523,20 @@
     def label(self):
         portal_language = getUtility(IKofaUtils).PORTAL_LANGUAGE
-        return translate(_('Clearance Slip of '),
+        return translate(_('Clearance Slip of'),
             'waeup.kofa', target_language=portal_language) \
             + ' %s' % self.context.display_fullname
 
+    def _signatures(self):
+        if self.context.state == CLEARED:
+            return (_('Student Signature'), _('Clearance Officer Signature'))
+        return
+
     def render(self):
-        studentview = StudentBaseDisplayFormPage(self.context.student,
+        studentview = StudentBasePDFFormPage(self.context.student,
             self.request)
         students_utils = getUtility(IStudentsUtils)
         return students_utils.renderPDF(
             self, 'clearance.pdf',
-            self.context.student, studentview)
+            self.context.student, studentview, signatures=self._signatures())
 
 class StudentClearanceManageFormPage(KofaEditFormPage):
@@ -475,7 +557,7 @@
     def form_fields(self):
         if self.context.is_postgrad:
-            form_fields = grok.AutoFields(IPGStudentClearance)
-        else:
-            form_fields = grok.AutoFields(IUGStudentClearance)
+            form_fields = grok.AutoFields(IPGStudentClearance).omit('clr_code')
+        else:
+            form_fields = grok.AutoFields(IUGStudentClearance).omit('clr_code')
         return form_fields
 
@@ -557,12 +639,12 @@
             mapping = {'a':self.context.display_fullname})
 
-class StudentPersonalEditFormPage(KofaEditFormPage):
-    """ Page to edit personal data
+class StudentPersonalManageFormPage(KofaEditFormPage):
+    """ Page to manage personal data
     """
     grok.context(IStudent)
-    grok.name('edit_personal')
-    grok.require('waeup.handleStudent')
+    grok.name('manage_personal')
+    grok.require('waeup.manageStudent')
     form_fields = grok.AutoFields(IStudentPersonal)
-    label = _('Edit personal data')
+    label = _('Manage personal data')
     pnav = 4
 
@@ -572,4 +654,12 @@
         return
 
+class StudentPersonalEditFormPage(StudentPersonalManageFormPage):
+    """ Page to edit personal data
+    """
+    grok.name('edit_personal')
+    grok.require('waeup.handleStudent')
+    label = _('Edit personal data')
+    pnav = 4
+
 class StudyCourseDisplayFormPage(KofaDisplayFormPage):
     """ Page to display the student study course data
@@ -578,12 +668,24 @@
     grok.name('index')
     grok.require('waeup.viewStudent')
-    form_fields = grok.AutoFields(IStudentStudyCourse)
     grok.template('studycoursepage')
     pnav = 4
 
     @property
+    def form_fields(self):
+        if self.context.is_postgrad:
+            form_fields = grok.AutoFields(IStudentStudyCourse).omit(
+                'current_verdict', 'previous_verdict')
+        else:
+            form_fields = grok.AutoFields(IStudentStudyCourse)
+        return form_fields
+
+    @property
     def label(self):
-        return _('${a}: Study Course',
-            mapping = {'a':self.context.__parent__.display_fullname})
+        if self.context.is_current:
+            return _('${a}: Study Course',
+                mapping = {'a':self.context.__parent__.display_fullname})
+        else:
+            return _('${a}: Previous Study Course',
+                mapping = {'a':self.context.__parent__.display_fullname})
 
     @property
@@ -606,4 +708,21 @@
         return
 
+    @property
+    def prev_studycourses(self):
+        if self.context.is_current:
+            if self.context.__parent__.get('studycourse_2', None) is not None:
+                return (
+                        {'href':self.url(self.context.student) + '/studycourse_1',
+                        'title':_('First Study Course, ')},
+                        {'href':self.url(self.context.student) + '/studycourse_2',
+                        'title':_('Second Study Course')}
+                        )
+            if self.context.__parent__.get('studycourse_1', None) is not None:
+                return (
+                        {'href':self.url(self.context.student) + '/studycourse_1',
+                        'title':_('First Study Course')},
+                        )
+        return
+
 class StudyCourseManageFormPage(KofaEditFormPage):
     """ Page to edit the student study course data
@@ -613,5 +732,4 @@
     grok.require('waeup.manageStudent')
     grok.template('studycoursemanagepage')
-    form_fields = grok.AutoFields(IStudentStudyCourse)
     label = _('Manage study course')
     pnav = 4
@@ -620,5 +738,17 @@
     tabthreeactions = [_('Add study level')]
 
+    @property
+    def form_fields(self):
+        if self.context.is_postgrad:
+            form_fields = grok.AutoFields(IStudentStudyCourse).omit(
+                'current_verdict', 'previous_verdict')
+        else:
+            form_fields = grok.AutoFields(IStudentStudyCourse)
+        return form_fields
+
     def update(self):
+        if not self.context.is_current:
+            emit_lock_message(self)
+            return
         super(StudyCourseManageFormPage, self).update()
         tabs.need()
@@ -685,4 +815,33 @@
         return
 
+class StudentTransferFormPage(KofaAddFormPage):
+    """Page to transfer the student.
+    """
+    grok.context(IStudent)
+    grok.name('transfer')
+    grok.require('waeup.manageStudent')
+    label = _('Transfer student')
+    form_fields = grok.AutoFields(IStudentStudyCourseTransfer).omit(
+        'entry_mode', 'entry_session')
+    pnav = 4
+
+    def update(self):
+        super(StudentTransferFormPage, self).update()
+        warning.need()
+        return
+
+    @jsaction(_('Transfer'))
+    def transferStudent(self, **data):
+        error = self.context.transfer(**data)
+        if error == -1:
+            self.flash(_('Current level does not match certificate levels.'))
+        elif error == -2:
+            self.flash(_('Former study course record incomplete.'))
+        elif error == -3:
+            self.flash(_('Maximum number of transfers exceeded.'))
+        else:
+            self.flash(_('Successfully transferred.'))
+        return
+
 class StudyLevelDisplayFormPage(KofaDisplayFormPage):
     """ Page to display student study levels
@@ -692,4 +851,6 @@
     grok.require('waeup.viewStudent')
     form_fields = grok.AutoFields(IStudentStudyLevel)
+    form_fields[
+        'validation_date'].custom_widget = FriendlyDatetimeDisplayWidget('le')
     grok.template('studylevelpage')
     pnav = 4
@@ -702,14 +863,5 @@
     @property
     def translated_values(self):
-        lang = self.request.cookies.get('kofa.language')
-        for value in self.context.values():
-            value_dict = dict([i for i in value.__dict__.items()])
-            value_dict['mandatory'] = translate(str(value.mandatory), 'zope',
-                target_language=lang)
-            value_dict['carry_over'] = translate(str(value.carry_over), 'zope',
-                target_language=lang)
-            value_dict['automatic'] = translate(str(value.automatic), 'zope',
-                target_language=lang)
-            yield value_dict
+        return translated_values(self)
 
     @property
@@ -771,5 +923,5 @@
         Mand = translate(_('Mand.'), 'waeup.kofa', target_language=portal_language)
         Score = translate(_('Score'), 'waeup.kofa', target_language=portal_language)
-        studentview = StudentBaseDisplayFormPage(self.context.student,
+        studentview = StudentBasePDFFormPage(self.context.student,
             self.request)
         students_utils = getUtility(IStudentsUtils)
@@ -796,5 +948,6 @@
     grok.require('waeup.manageStudent')
     grok.template('studylevelmanagepage')
-    form_fields = grok.AutoFields(IStudentStudyLevel)
+    form_fields = grok.AutoFields(IStudentStudyLevel).omit(
+        'validation_date', 'validated_by')
     pnav = 4
     taboneactions = [_('Save'),_('Cancel')]
@@ -803,4 +956,7 @@
 
     def update(self):
+        if not self.context.__parent__.is_current:
+            emit_lock_message(self)
+            return
         super(StudyLevelManageFormPage, self).update()
         tabs.need()
@@ -813,4 +969,8 @@
         datatable.need()
         return
+
+    @property
+    def translated_values(self):
+        return translated_values(self)
 
     @property
@@ -861,4 +1021,7 @@
 
     def update(self):
+        if not self.context.__parent__.is_current:
+            emit_lock_message(self)
+            return
         if str(self.context.__parent__.current_level) != self.context.__name__:
             self.flash(_('This level does not correspond current level.'))
@@ -883,4 +1046,7 @@
 
     def update(self):
+        if not self.context.__parent__.is_current:
+            emit_lock_message(self)
+            return
         if str(self.context.__parent__.current_level) != self.context.__name__:
             self.flash(_('This level does not correspond current level.'))
@@ -918,4 +1084,11 @@
     pnav = 4
 
+    def update(self):
+        if not self.context.__parent__.is_current:
+            emit_lock_message(self)
+            return
+        super(CourseTicketAddFormPage, self).update()
+        return
+
     @action(_('Add course ticket'))
     def addCourseTicket(self, **data):
@@ -924,13 +1097,6 @@
         ticket.automatic = False
         ticket.carry_over = False
-        ticket.code = course.code
-        ticket.title = course.title
-        ticket.fcode = course.__parent__.__parent__.__parent__.code
-        ticket.dcode = course.__parent__.__parent__.code
-        ticket.credits = course.credits
-        ticket.passmark = course.passmark
-        ticket.semester = course.semester
         try:
-            self.context.addCourseTicket(ticket)
+            self.context.addCourseTicket(ticket, course)
         except KeyError:
             self.flash(_('The ticket exists.'))
@@ -1030,5 +1196,5 @@
                 mapping = {'a': ', '.join(deleted)}))
             self.context.writeLogMessage(
-                self,'removed: % s' % ', '.join(deleted))
+                self,'removed: %s' % ', '.join(deleted))
         self.redirect(self.url(self.context))
         return
@@ -1052,4 +1218,6 @@
     def createTicket(self, **data):
         p_category = data['p_category']
+        previous_session = data.get('p_session', None)
+        previous_level = data.get('p_level', None)
         student = self.context.__parent__
         if p_category == 'bed_allocation' and student[
@@ -1062,7 +1230,11 @@
                 return
         students_utils = getUtility(IStudentsUtils)
-        error, payment = students_utils.setPaymentDetails(p_category, student)
+        error, payment = students_utils.setPaymentDetails(
+            p_category, student, previous_session, previous_level)
         if error is not None:
             self.flash(error)
+            if 'Would you like' in error:
+                self.redirect(self.url(self.context) + '/@@addpp')
+                return
             self.redirect(self.url(self.context))
             return
@@ -1071,4 +1243,15 @@
         self.redirect(self.url(self.context))
         return
+
+class PreviousPaymentAddFormPage(OnlinePaymentAddFormPage):
+    """ Page to add an online payment ticket for previous sessions
+    """
+    grok.context(IStudentPaymentsContainer)
+    grok.name('addpp')
+    grok.require('waeup.payStudent')
+    form_fields = grok.AutoFields(IStudentPreviousPayment).select(
+        'p_category', 'p_session', 'p_level')
+    label = _('Add previous session online payment')
+    pnav = 4
 
 class OnlinePaymentDisplayFormPage(KofaDisplayFormPage):
@@ -1149,5 +1332,5 @@
         #    self.redirect(self.url(self.context))
         #    return
-        studentview = StudentBaseDisplayFormPage(self.context.student,
+        studentview = StudentBasePDFFormPage(self.context.student,
             self.request)
         students_utils = getUtility(IStudentsUtils)
@@ -1369,5 +1552,5 @@
 
     def render(self):
-        studentview = StudentBaseDisplayFormPage(self.context.student,
+        studentview = StudentBasePDFFormPage(self.context.student,
             self.request)
         students_utils = getUtility(IStudentsUtils)
@@ -1569,17 +1752,16 @@
             self.flash(_('Activation code is invalid.'))
             return
+        if code.state == USED:
+            self.flash(_('Activation code has already been used.'))
+            return
         # Mark pin as used (this also fires a pin related transition)
         # and fire transition start_clearance
-        if code.state == USED:
-            self.flash(_('Activation code has already been used.'))
-            return
-        else:
-            comment = _(u"invalidated")
-            # Here we know that the ac is in state initialized so we do not
-            # expect an exception, but the owner might be different
-            if not invalidate_accesscode(pin,comment,self.context.student_id):
-                self.flash(_('You are not the owner of this access code.'))
-                return
-            self.context.clr_code = pin
+        comment = _(u"invalidated")
+        # Here we know that the ac is in state initialized so we do not
+        # expect an exception, but the owner might be different
+        if not invalidate_accesscode(pin, comment, self.context.student_id):
+            self.flash(_('You are not the owner of this access code.'))
+            return
+        self.context.clr_code = pin
         IWorkflowInfo(self.context).fireTransition('start_clearance')
         self.flash(_('Clearance process has been started.'))
@@ -1598,7 +1780,9 @@
     def form_fields(self):
         if self.context.is_postgrad:
-            form_fields = grok.AutoFields(IPGStudentClearance).omit('clearance_locked')
-        else:
-            form_fields = grok.AutoFields(IUGStudentClearance).omit('clearance_locked')
+            form_fields = grok.AutoFields(IPGStudentClearance).omit(
+                'clearance_locked', 'clr_code')
+        else:
+            form_fields = grok.AutoFields(IUGStudentClearance).omit(
+                'clearance_locked', 'clr_code')
         return form_fields
 
@@ -1627,5 +1811,19 @@
             return
         self.flash(_('Clearance form has been saved.'))
-        self.redirect(self.url(self.context,'request_clearance'))
+        if self.context.clr_code:
+            self.redirect(self.url(self.context, 'request_clearance'))
+        else:
+            # We bypass the request_clearance page if student
+            # has been imported in state 'clearance started' and
+            # no clr_code was entered before.
+            state = IWorkflowState(self.context).getState()
+            if state != CLEARANCE:
+                # This shouldn't happen, but the application officer
+                # might have forgotten to lock the form after changing the state
+                self.flash(_('This form cannot be submitted. Wrong state!'))
+                return
+            IWorkflowInfo(self.context).fireTransition('request_clearance')
+            self.flash(_('Clearance has been requested.'))
+            self.redirect(self.url(self.context))
         return
 
@@ -1647,11 +1845,11 @@
             return
         pin = '%s-%s-%s' % (self.ac_prefix, self.ac_series, self.ac_number)
-        if self.context.clr_code != pin:
+        if self.context.clr_code and self.context.clr_code != pin:
             self.flash(_("This isn't your CLR access code."))
             return
         state = IWorkflowState(self.context).getState()
-        # This shouldn't happen, but the application officer
-        # might have forgotten to lock the form after changing the state
         if state != CLEARANCE:
+            # This shouldn't happen, but the application officer
+            # might have forgotten to lock the form after changing the state
             self.flash(_('This form cannot be submitted. Wrong state!'))
             return
@@ -1673,4 +1871,8 @@
 
     def update(self, SUBMIT=None):
+        if not self.context.is_current:
+            emit_lock_message(self)
+            return
+        super(StartSessionPage, self).update()
         if not self.context.next_session_allowed:
             self.flash(_("You are not entitled to start session."))
@@ -1730,4 +1932,7 @@
 
     def update(self):
+        if not self.context.is_current:
+            emit_lock_message(self)
+            return
         if self.context.student.state != PAID:
             emit_lock_message(self)
@@ -1762,4 +1967,7 @@
 
     def update(self):
+        if not self.context.__parent__.is_current:
+            emit_lock_message(self)
+            return
         if self.context.student.state != PAID:
             emit_lock_message(self)
@@ -1776,5 +1984,5 @@
         level_title = translate(self.context.level_title, 'waeup.kofa',
             target_language=lang)
-        return _('Add and remove course tickets of study level ${a}',
+        return _('Edit course list of ${a}',
             mapping = {'a':level_title})
 
@@ -1785,4 +1993,8 @@
             total_credits += val.credits
         return total_credits
+
+    @property
+    def translated_values(self):
+        return translated_values(self)
 
     @action(_('Add course ticket'))
@@ -1847,9 +2059,8 @@
         ticket = createObject(u'waeup.CourseTicket')
         course = data['course']
-        for name in ['code', 'title', 'credits', 'passmark', 'semester']:
-            setattr(ticket, name, getattr(course, name))
         ticket.automatic = False
+        ticket.carry_over = False
         try:
-            self.context.addCourseTicket(ticket)
+            self.context.addCourseTicket(ticket, course)
         except KeyError:
             self.flash(_('The ticket exists.'))
@@ -1927,5 +2138,5 @@
     grok.template('requestpw')
     form_fields = grok.AutoFields(IStudentRequestPW).select(
-        'firstname','reg_number','email')
+        'firstname','number','email')
     label = _('Request password for first-time login')
 
@@ -1948,5 +2159,5 @@
         return True
 
-    @action(_('Get login credentials'), style='primary')
+    @action(_('Send login credentials to email address'), style='primary')
     def get_credentials(self, **data):
         if not self.captcha_result.is_valid:
@@ -1954,9 +2165,12 @@
             # No need to flash something.
             return
-        reg_number = data.get('reg_number','')
+        number = data.get('number','')
         firstname = data.get('firstname','')
         cat = getUtility(ICatalog, name='students_catalog')
         results = list(
-            cat.searchResults(reg_number=(reg_number, reg_number)))
+            cat.searchResults(reg_number=(number, number)))
+        if not results:
+            results = list(
+                cat.searchResults(matric_number=(number, number)))
         if results:
             student = results[0]
@@ -1984,10 +2198,16 @@
         kofa_utils = getUtility(IKofaUtils)
         password = kofa_utils.genPassword()
-        IUserAccount(student).setPassword(password)
+        mandate = PasswordMandate()
+        mandate.params['password'] = password
+        mandate.params['user'] = student
+        site = grok.getSite()
+        site['mandates'].addMandate(mandate)
         # Send email with credentials
-        login_url = self.url(grok.getSite(), 'login')
+        args = {'mandate_id':mandate.mandate_id}
+        mandate_url = self.url(site) + '/mandate?%s' % urlencode(args)
+        url_info = u'Confirmation link: %s' % mandate_url
         msg = _('You have successfully requested a password for the')
         if kofa_utils.sendCredentials(IUserAccount(student),
-            password, login_url, msg):
+            password, url_info, msg):
             email_sent = student.email
         else:
@@ -1995,4 +2215,7 @@
         self._redirect(email=email_sent, password=password,
             student_id=student.student_id)
+        ob_class = self.__implemented__.__name__.replace('waeup.kofa.','')
+        self.context.logger.info(
+            '%s - %s (%s) - %s' % (ob_class, number, student.student_id, email_sent))
         return
 
Index: main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/browser_templates/requestpw.pt
===================================================================
--- main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/browser_templates/requestpw.pt	(revision 9168)
+++ main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/browser_templates/requestpw.pt	(revision 9169)
@@ -17,6 +17,7 @@
   </table>
   <p i18n:translate="">
-    Your student record will be looked up and an email with your login
-    credentials will be sent to the address provided.
+    Your student record will be looked up and
+    your login credentials will be sent to the email address given above.
+    To be able to proceed you must provide a valid email address!
   </p>
   <div tal:condition="view/availableActions">
Index: main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/browser_templates/requestpwmailsent.pt
===================================================================
--- main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/browser_templates/requestpwmailsent.pt	(revision 9168)
+++ main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/browser_templates/requestpwmailsent.pt	(revision 9169)
@@ -29,9 +29,10 @@
     <tr>
   </table>
-  <p i18n:translate="">
-    Print this page and proceed to the
+  <p>
+    <span i18n:translate="">Print this page and proceed to the</span>
     <a tal:attributes="href python: view.url(layout.site, 'login')">login form</a>.
-    Please note that passwords are case-sensitive,
+    <span i18n:translate="">Please note that passwords are case-sensitive,
     <br />when entering your credentials, and keep your password secret!
+    </span>
   </p>
   <p tal:condition = "view/email">
Index: main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/browser_templates/studycoursepage.pt
===================================================================
--- main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/browser_templates/studycoursepage.pt	(revision 9168)
+++ main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/browser_templates/studycoursepage.pt	(revision 9169)
@@ -47,4 +47,16 @@
         </td>
       </tr>
+      <tr tal:condition="view/prev_studycourses">
+        <td i18n:translate="">
+            Previous Study Courses:
+        </td>
+        <td>
+          <span tal:repeat="value view/prev_studycourses">
+            <a tal:attributes="href value/href" tal:content="value/title">
+              FACULTY
+            </a>
+          </span>
+        </td>
+      </tr>
   </tbody>
 </table>
Index: main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/browser_templates/studyleveleditpage.pt
===================================================================
--- main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/browser_templates/studyleveleditpage.pt	(revision 9168)
+++ main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/browser_templates/studyleveleditpage.pt	(revision 9169)
@@ -22,9 +22,9 @@
   </thead>
   <tbody>
-    <tr tal:repeat="value context/values" class="gradeC">
+    <tr tal:repeat="value view/translated_values" class="gradeC">
        <td>
         <input type="checkbox" name="val_id"
   		  tal:attributes="value value/__name__"
-        tal:condition="not: value/mandatory" />
+        tal:condition="not: value/mandatory_bool" />
       </td>
       <td tal:content="value/semester">SEMESTER</td>
@@ -36,5 +36,5 @@
       <td tal:content="value/fcode">FACULTY</td>
       <td tal:content="value/credits">CREDITS</td>
-      <td tal:content="value/score">SCORE</td>
+      <td tal:content="value/score|nothing">SCORE</td>
       <td tal:content="value/carry_over">CO</td>
     </tr>
